<?php

/**
 * @file
 * Contains \Drupal\masquerade\MasqueradePermissions.
 */

namespace Drupal\masquerade;

use Drupal\Core\StringTranslation\StringTranslationTrait;

/**
 * Provides dynamic permissions of the masquerade module.
 */
class MasqueradePermissions {

  use StringTranslationTrait;

  /**
   * Returns an array of masquerade permissions.
   *
   * @todo Allow permissions for each role to masquerade as as subset of roles
   *   https://drupal.org/node/1171500
   *
   * @return array
   */
  public function permissions() {
    $permissions = [];

    // Anonymous was intentionally left out. Logout instead.
    $roles = user_roles(TRUE);
    foreach ($roles as $rid => $role) {
      $permissions['masquerade as ' . $role->id()] = [
        'title' => $this->t('Masquerade as @role', ['@role' => $role->label()]),
        'restrict access' => TRUE
      ];
    }

    return $permissions;
  }

}
